// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from automotive_navigation_msgs:msg/PointOfInterest.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "automotive_navigation_msgs/msg/detail/point_of_interest__functions.h"
#include "automotive_navigation_msgs/msg/detail/point_of_interest__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace automotive_navigation_msgs
{

namespace msg
{

namespace rosidl_typesupport_introspection_cpp
{

void PointOfInterest_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) automotive_navigation_msgs::msg::PointOfInterest(_init);
}

void PointOfInterest_fini_function(void * message_memory)
{
  auto typed_message = static_cast<automotive_navigation_msgs::msg::PointOfInterest *>(message_memory);
  typed_message->~PointOfInterest();
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember PointOfInterest_message_member_array[4] = {
  {
    "guid",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_UINT64,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is key
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(automotive_navigation_msgs::msg::PointOfInterest, guid),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "latitude",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_DOUBLE,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is key
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(automotive_navigation_msgs::msg::PointOfInterest, latitude),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "longitude",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_DOUBLE,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is key
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(automotive_navigation_msgs::msg::PointOfInterest, longitude),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "params",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_STRING,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is key
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(automotive_navigation_msgs::msg::PointOfInterest, params),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers PointOfInterest_message_members = {
  "automotive_navigation_msgs::msg",  // message namespace
  "PointOfInterest",  // message name
  4,  // number of fields
  sizeof(automotive_navigation_msgs::msg::PointOfInterest),
  false,  // has_any_key_member_
  PointOfInterest_message_member_array,  // message members
  PointOfInterest_init_function,  // function to initialize message memory (memory has to be allocated)
  PointOfInterest_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t PointOfInterest_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &PointOfInterest_message_members,
  get_message_typesupport_handle_function,
  &automotive_navigation_msgs__msg__PointOfInterest__get_type_hash,
  &automotive_navigation_msgs__msg__PointOfInterest__get_type_description,
  &automotive_navigation_msgs__msg__PointOfInterest__get_type_description_sources,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace msg

}  // namespace automotive_navigation_msgs


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<automotive_navigation_msgs::msg::PointOfInterest>()
{
  return &::automotive_navigation_msgs::msg::rosidl_typesupport_introspection_cpp::PointOfInterest_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, automotive_navigation_msgs, msg, PointOfInterest)() {
  return &::automotive_navigation_msgs::msg::rosidl_typesupport_introspection_cpp::PointOfInterest_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif
