// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from automotive_navigation_msgs:msg/RoadNetworkBoundaries.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "automotive_navigation_msgs/msg/road_network_boundaries.hpp"


#ifndef AUTOMOTIVE_NAVIGATION_MSGS__MSG__DETAIL__ROAD_NETWORK_BOUNDARIES__STRUCT_HPP_
#define AUTOMOTIVE_NAVIGATION_MSGS__MSG__DETAIL__ROAD_NETWORK_BOUNDARIES__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'road_network_boundaries'
#include "automotive_navigation_msgs/msg/detail/lane_boundary_array__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__automotive_navigation_msgs__msg__RoadNetworkBoundaries __attribute__((deprecated))
#else
# define DEPRECATED__automotive_navigation_msgs__msg__RoadNetworkBoundaries __declspec(deprecated)
#endif

namespace automotive_navigation_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RoadNetworkBoundaries_
{
  using Type = RoadNetworkBoundaries_<ContainerAllocator>;

  explicit RoadNetworkBoundaries_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    (void)_init;
  }

  explicit RoadNetworkBoundaries_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _road_network_boundaries_type =
    std::vector<automotive_navigation_msgs::msg::LaneBoundaryArray_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<automotive_navigation_msgs::msg::LaneBoundaryArray_<ContainerAllocator>>>;
  _road_network_boundaries_type road_network_boundaries;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__road_network_boundaries(
    const std::vector<automotive_navigation_msgs::msg::LaneBoundaryArray_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<automotive_navigation_msgs::msg::LaneBoundaryArray_<ContainerAllocator>>> & _arg)
  {
    this->road_network_boundaries = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    automotive_navigation_msgs::msg::RoadNetworkBoundaries_<ContainerAllocator> *;
  using ConstRawPtr =
    const automotive_navigation_msgs::msg::RoadNetworkBoundaries_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<automotive_navigation_msgs::msg::RoadNetworkBoundaries_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<automotive_navigation_msgs::msg::RoadNetworkBoundaries_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      automotive_navigation_msgs::msg::RoadNetworkBoundaries_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<automotive_navigation_msgs::msg::RoadNetworkBoundaries_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      automotive_navigation_msgs::msg::RoadNetworkBoundaries_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<automotive_navigation_msgs::msg::RoadNetworkBoundaries_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<automotive_navigation_msgs::msg::RoadNetworkBoundaries_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<automotive_navigation_msgs::msg::RoadNetworkBoundaries_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__automotive_navigation_msgs__msg__RoadNetworkBoundaries
    std::shared_ptr<automotive_navigation_msgs::msg::RoadNetworkBoundaries_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__automotive_navigation_msgs__msg__RoadNetworkBoundaries
    std::shared_ptr<automotive_navigation_msgs::msg::RoadNetworkBoundaries_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RoadNetworkBoundaries_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->road_network_boundaries != other.road_network_boundaries) {
      return false;
    }
    return true;
  }
  bool operator!=(const RoadNetworkBoundaries_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RoadNetworkBoundaries_

// alias to use template instance with default allocator
using RoadNetworkBoundaries =
  automotive_navigation_msgs::msg::RoadNetworkBoundaries_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace automotive_navigation_msgs

#endif  // AUTOMOTIVE_NAVIGATION_MSGS__MSG__DETAIL__ROAD_NETWORK_BOUNDARIES__STRUCT_HPP_
