// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from automotive_navigation_msgs:msg/RoadNetworkBoundaries.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "automotive_navigation_msgs/msg/road_network_boundaries.hpp"


#ifndef AUTOMOTIVE_NAVIGATION_MSGS__MSG__DETAIL__ROAD_NETWORK_BOUNDARIES__TRAITS_HPP_
#define AUTOMOTIVE_NAVIGATION_MSGS__MSG__DETAIL__ROAD_NETWORK_BOUNDARIES__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "automotive_navigation_msgs/msg/detail/road_network_boundaries__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'road_network_boundaries'
#include "automotive_navigation_msgs/msg/detail/lane_boundary_array__traits.hpp"

namespace automotive_navigation_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const RoadNetworkBoundaries & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: road_network_boundaries
  {
    if (msg.road_network_boundaries.size() == 0) {
      out << "road_network_boundaries: []";
    } else {
      out << "road_network_boundaries: [";
      size_t pending_items = msg.road_network_boundaries.size();
      for (auto item : msg.road_network_boundaries) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const RoadNetworkBoundaries & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: road_network_boundaries
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.road_network_boundaries.size() == 0) {
      out << "road_network_boundaries: []\n";
    } else {
      out << "road_network_boundaries:\n";
      for (auto item : msg.road_network_boundaries) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const RoadNetworkBoundaries & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace automotive_navigation_msgs

namespace rosidl_generator_traits
{

[[deprecated("use automotive_navigation_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const automotive_navigation_msgs::msg::RoadNetworkBoundaries & msg,
  std::ostream & out, size_t indentation = 0)
{
  automotive_navigation_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use automotive_navigation_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const automotive_navigation_msgs::msg::RoadNetworkBoundaries & msg)
{
  return automotive_navigation_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<automotive_navigation_msgs::msg::RoadNetworkBoundaries>()
{
  return "automotive_navigation_msgs::msg::RoadNetworkBoundaries";
}

template<>
inline const char * name<automotive_navigation_msgs::msg::RoadNetworkBoundaries>()
{
  return "automotive_navigation_msgs/msg/RoadNetworkBoundaries";
}

template<>
struct has_fixed_size<automotive_navigation_msgs::msg::RoadNetworkBoundaries>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<automotive_navigation_msgs::msg::RoadNetworkBoundaries>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<automotive_navigation_msgs::msg::RoadNetworkBoundaries>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // AUTOMOTIVE_NAVIGATION_MSGS__MSG__DETAIL__ROAD_NETWORK_BOUNDARIES__TRAITS_HPP_
