// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from automotive_navigation_msgs:msg/DesiredDestination.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "automotive_navigation_msgs/msg/desired_destination.hpp"


#ifndef AUTOMOTIVE_NAVIGATION_MSGS__MSG__DETAIL__DESIRED_DESTINATION__STRUCT_HPP_
#define AUTOMOTIVE_NAVIGATION_MSGS__MSG__DETAIL__DESIRED_DESTINATION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__automotive_navigation_msgs__msg__DesiredDestination __attribute__((deprecated))
#else
# define DEPRECATED__automotive_navigation_msgs__msg__DesiredDestination __declspec(deprecated)
#endif

namespace automotive_navigation_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct DesiredDestination_
{
  using Type = DesiredDestination_<ContainerAllocator>;

  explicit DesiredDestination_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->msg_counter = 0;
      this->valid = 0;
      this->latitude = 0.0;
      this->longitude = 0.0;
    }
  }

  explicit DesiredDestination_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->msg_counter = 0;
      this->valid = 0;
      this->latitude = 0.0;
      this->longitude = 0.0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _msg_counter_type =
    uint8_t;
  _msg_counter_type msg_counter;
  using _valid_type =
    uint16_t;
  _valid_type valid;
  using _latitude_type =
    double;
  _latitude_type latitude;
  using _longitude_type =
    double;
  _longitude_type longitude;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__msg_counter(
    const uint8_t & _arg)
  {
    this->msg_counter = _arg;
    return *this;
  }
  Type & set__valid(
    const uint16_t & _arg)
  {
    this->valid = _arg;
    return *this;
  }
  Type & set__latitude(
    const double & _arg)
  {
    this->latitude = _arg;
    return *this;
  }
  Type & set__longitude(
    const double & _arg)
  {
    this->longitude = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    automotive_navigation_msgs::msg::DesiredDestination_<ContainerAllocator> *;
  using ConstRawPtr =
    const automotive_navigation_msgs::msg::DesiredDestination_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<automotive_navigation_msgs::msg::DesiredDestination_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<automotive_navigation_msgs::msg::DesiredDestination_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      automotive_navigation_msgs::msg::DesiredDestination_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<automotive_navigation_msgs::msg::DesiredDestination_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      automotive_navigation_msgs::msg::DesiredDestination_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<automotive_navigation_msgs::msg::DesiredDestination_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<automotive_navigation_msgs::msg::DesiredDestination_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<automotive_navigation_msgs::msg::DesiredDestination_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__automotive_navigation_msgs__msg__DesiredDestination
    std::shared_ptr<automotive_navigation_msgs::msg::DesiredDestination_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__automotive_navigation_msgs__msg__DesiredDestination
    std::shared_ptr<automotive_navigation_msgs::msg::DesiredDestination_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DesiredDestination_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->msg_counter != other.msg_counter) {
      return false;
    }
    if (this->valid != other.valid) {
      return false;
    }
    if (this->latitude != other.latitude) {
      return false;
    }
    if (this->longitude != other.longitude) {
      return false;
    }
    return true;
  }
  bool operator!=(const DesiredDestination_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DesiredDestination_

// alias to use template instance with default allocator
using DesiredDestination =
  automotive_navigation_msgs::msg::DesiredDestination_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace automotive_navigation_msgs

#endif  // AUTOMOTIVE_NAVIGATION_MSGS__MSG__DETAIL__DESIRED_DESTINATION__STRUCT_HPP_
