// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from automotive_navigation_msgs:msg/LaneBoundary.idl
// generated code does not contain a copyright notice

#include "automotive_navigation_msgs/msg/detail/lane_boundary__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_automotive_navigation_msgs
const rosidl_type_hash_t *
automotive_navigation_msgs__msg__LaneBoundary__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0xe0, 0x87, 0x31, 0xda, 0xf8, 0x94, 0x31, 0x49,
      0xaa, 0xc7, 0x0a, 0xc6, 0x47, 0xd5, 0x64, 0xd2,
      0x00, 0x7d, 0x6b, 0x99, 0x3f, 0x04, 0x63, 0x4a,
      0x1e, 0xc5, 0xae, 0xa8, 0x4d, 0x99, 0x03, 0xd2,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types
#include "geometry_msgs/msg/detail/point__functions.h"

// Hashes for external referenced types
#ifndef NDEBUG
static const rosidl_type_hash_t geometry_msgs__msg__Point__EXPECTED_HASH = {1, {
    0x69, 0x63, 0x08, 0x48, 0x42, 0xa9, 0xb0, 0x44,
    0x94, 0xd6, 0xb2, 0x94, 0x1d, 0x11, 0x44, 0x47,
    0x08, 0xd8, 0x92, 0xda, 0x2f, 0x4b, 0x09, 0x84,
    0x3b, 0x9c, 0x43, 0xf4, 0x2a, 0x7f, 0x68, 0x81,
  }};
#endif

static char automotive_navigation_msgs__msg__LaneBoundary__TYPE_NAME[] = "automotive_navigation_msgs/msg/LaneBoundary";
static char geometry_msgs__msg__Point__TYPE_NAME[] = "geometry_msgs/msg/Point";

// Define type names, field names, and default values
static char automotive_navigation_msgs__msg__LaneBoundary__FIELD_NAME__style[] = "style";
static char automotive_navigation_msgs__msg__LaneBoundary__FIELD_NAME__color[] = "color";
static char automotive_navigation_msgs__msg__LaneBoundary__FIELD_NAME__line[] = "line";

static rosidl_runtime_c__type_description__Field automotive_navigation_msgs__msg__LaneBoundary__FIELDS[] = {
  {
    {automotive_navigation_msgs__msg__LaneBoundary__FIELD_NAME__style, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {automotive_navigation_msgs__msg__LaneBoundary__FIELD_NAME__color, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {automotive_navigation_msgs__msg__LaneBoundary__FIELD_NAME__line, 4, 4},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_NESTED_TYPE_UNBOUNDED_SEQUENCE,
      0,
      0,
      {geometry_msgs__msg__Point__TYPE_NAME, 23, 23},
    },
    {NULL, 0, 0},
  },
};

static rosidl_runtime_c__type_description__IndividualTypeDescription automotive_navigation_msgs__msg__LaneBoundary__REFERENCED_TYPE_DESCRIPTIONS[] = {
  {
    {geometry_msgs__msg__Point__TYPE_NAME, 23, 23},
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
automotive_navigation_msgs__msg__LaneBoundary__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {automotive_navigation_msgs__msg__LaneBoundary__TYPE_NAME, 43, 43},
      {automotive_navigation_msgs__msg__LaneBoundary__FIELDS, 3, 3},
    },
    {automotive_navigation_msgs__msg__LaneBoundary__REFERENCED_TYPE_DESCRIPTIONS, 1, 1},
  };
  if (!constructed) {
    assert(0 == memcmp(&geometry_msgs__msg__Point__EXPECTED_HASH, geometry_msgs__msg__Point__get_type_hash(NULL), sizeof(rosidl_type_hash_t)));
    description.referenced_type_descriptions.data[0].fields = geometry_msgs__msg__Point__get_type_description(NULL)->type_description.fields;
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# Lane Boundary Message\n"
  "# Contains an array of points and other details\n"
  "\n"
  "uint8 UNKNOWN=0\n"
  "\n"
  "uint8 SOLID=1\n"
  "uint8 DASHED=2\n"
  "uint8 SOLID_DASHED=3\n"
  "uint8 DASHED_SOLID=4\n"
  "uint8 SOLID_SOLID=5\n"
  "uint8 style\n"
  "\n"
  "uint8 WHITE=1\n"
  "uint8 YELLOW=2\n"
  "uint8 color\n"
  "\n"
  "geometry_msgs/Point[] line";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
automotive_navigation_msgs__msg__LaneBoundary__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {automotive_navigation_msgs__msg__LaneBoundary__TYPE_NAME, 43, 43},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 263, 263},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
automotive_navigation_msgs__msg__LaneBoundary__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[2];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 2, 2};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *automotive_navigation_msgs__msg__LaneBoundary__get_individual_type_description_source(NULL),
    sources[1] = *geometry_msgs__msg__Point__get_individual_type_description_source(NULL);
    constructed = true;
  }
  return &source_sequence;
}
