// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from automotive_navigation_msgs:msg/PointOfInterest.idl
// generated code does not contain a copyright notice

#include "automotive_navigation_msgs/msg/detail/point_of_interest__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_automotive_navigation_msgs
const rosidl_type_hash_t *
automotive_navigation_msgs__msg__PointOfInterest__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x9e, 0x29, 0xc1, 0xb1, 0x96, 0x23, 0x24, 0x86,
      0xaf, 0xd9, 0x19, 0xa9, 0x08, 0x60, 0xbf, 0xe5,
      0xae, 0x22, 0x12, 0xe0, 0x0c, 0x8b, 0x32, 0x39,
      0x0f, 0x47, 0x27, 0x69, 0xb2, 0x94, 0xd8, 0xa5,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char automotive_navigation_msgs__msg__PointOfInterest__TYPE_NAME[] = "automotive_navigation_msgs/msg/PointOfInterest";

// Define type names, field names, and default values
static char automotive_navigation_msgs__msg__PointOfInterest__FIELD_NAME__guid[] = "guid";
static char automotive_navigation_msgs__msg__PointOfInterest__FIELD_NAME__latitude[] = "latitude";
static char automotive_navigation_msgs__msg__PointOfInterest__FIELD_NAME__longitude[] = "longitude";
static char automotive_navigation_msgs__msg__PointOfInterest__FIELD_NAME__params[] = "params";

static rosidl_runtime_c__type_description__Field automotive_navigation_msgs__msg__PointOfInterest__FIELDS[] = {
  {
    {automotive_navigation_msgs__msg__PointOfInterest__FIELD_NAME__guid, 4, 4},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT64,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {automotive_navigation_msgs__msg__PointOfInterest__FIELD_NAME__latitude, 8, 8},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_DOUBLE,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {automotive_navigation_msgs__msg__PointOfInterest__FIELD_NAME__longitude, 9, 9},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_DOUBLE,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {automotive_navigation_msgs__msg__PointOfInterest__FIELD_NAME__params, 6, 6},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_STRING,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
automotive_navigation_msgs__msg__PointOfInterest__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {automotive_navigation_msgs__msg__PointOfInterest__TYPE_NAME, 46, 46},
      {automotive_navigation_msgs__msg__PointOfInterest__FIELDS, 4, 4},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# Point of Interest Message\n"
  "# Contains the guid, latitude, longitude, and other information for a point of interest\n"
  "\n"
  "uint64 guid        # Unique Id for this point\n"
  "\n"
  "float64 latitude   # Latitude (degrees)\n"
  "float64 longitude  # Longitude (degrees)\n"
  "\n"
  "string params      # List of parameter:value pairs";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
automotive_navigation_msgs__msg__PointOfInterest__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {automotive_navigation_msgs__msg__PointOfInterest__TYPE_NAME, 46, 46},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 297, 297},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
automotive_navigation_msgs__msg__PointOfInterest__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *automotive_navigation_msgs__msg__PointOfInterest__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
