// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from automotive_navigation_msgs:msg/PointOfInterestResponse.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "automotive_navigation_msgs/msg/point_of_interest_response.h"


#ifndef AUTOMOTIVE_NAVIGATION_MSGS__MSG__DETAIL__POINT_OF_INTEREST_RESPONSE__STRUCT_H_
#define AUTOMOTIVE_NAVIGATION_MSGS__MSG__DETAIL__POINT_OF_INTEREST_RESPONSE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'name'
// Member 'module_name'
#include "rosidl_runtime_c/string.h"
// Member 'point_statuses'
#include "automotive_navigation_msgs/msg/detail/point_of_interest_status__struct.h"

/// Struct defined in msg/PointOfInterestResponse in the package automotive_navigation_msgs.
/**
  * Point of Interest Response Message
  * Contains status information about the points within the threshold
 */
typedef struct automotive_navigation_msgs__msg__PointOfInterestResponse
{
  std_msgs__msg__Header header;
  /// Name of the point of interest list
  rosidl_runtime_c__String name;
  /// module name of the requesting node
  rosidl_runtime_c__String module_name;
  /// Unique id of this request
  uint16_t request_id;
  /// The update number of the point list to use
  uint16_t update_num;
  /// The status information
  automotive_navigation_msgs__msg__PointOfInterestStatus__Sequence point_statuses;
} automotive_navigation_msgs__msg__PointOfInterestResponse;

// Struct for a sequence of automotive_navigation_msgs__msg__PointOfInterestResponse.
typedef struct automotive_navigation_msgs__msg__PointOfInterestResponse__Sequence
{
  automotive_navigation_msgs__msg__PointOfInterestResponse * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} automotive_navigation_msgs__msg__PointOfInterestResponse__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // AUTOMOTIVE_NAVIGATION_MSGS__MSG__DETAIL__POINT_OF_INTEREST_RESPONSE__STRUCT_H_
