// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from automotive_navigation_msgs:msg/RoadNetworkBoundaries.idl
// generated code does not contain a copyright notice
#include "automotive_navigation_msgs/msg/detail/road_network_boundaries__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `road_network_boundaries`
#include "automotive_navigation_msgs/msg/detail/lane_boundary_array__functions.h"

bool
automotive_navigation_msgs__msg__RoadNetworkBoundaries__init(automotive_navigation_msgs__msg__RoadNetworkBoundaries * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    automotive_navigation_msgs__msg__RoadNetworkBoundaries__fini(msg);
    return false;
  }
  // road_network_boundaries
  if (!automotive_navigation_msgs__msg__LaneBoundaryArray__Sequence__init(&msg->road_network_boundaries, 0)) {
    automotive_navigation_msgs__msg__RoadNetworkBoundaries__fini(msg);
    return false;
  }
  return true;
}

void
automotive_navigation_msgs__msg__RoadNetworkBoundaries__fini(automotive_navigation_msgs__msg__RoadNetworkBoundaries * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // road_network_boundaries
  automotive_navigation_msgs__msg__LaneBoundaryArray__Sequence__fini(&msg->road_network_boundaries);
}

bool
automotive_navigation_msgs__msg__RoadNetworkBoundaries__are_equal(const automotive_navigation_msgs__msg__RoadNetworkBoundaries * lhs, const automotive_navigation_msgs__msg__RoadNetworkBoundaries * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // road_network_boundaries
  if (!automotive_navigation_msgs__msg__LaneBoundaryArray__Sequence__are_equal(
      &(lhs->road_network_boundaries), &(rhs->road_network_boundaries)))
  {
    return false;
  }
  return true;
}

bool
automotive_navigation_msgs__msg__RoadNetworkBoundaries__copy(
  const automotive_navigation_msgs__msg__RoadNetworkBoundaries * input,
  automotive_navigation_msgs__msg__RoadNetworkBoundaries * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // road_network_boundaries
  if (!automotive_navigation_msgs__msg__LaneBoundaryArray__Sequence__copy(
      &(input->road_network_boundaries), &(output->road_network_boundaries)))
  {
    return false;
  }
  return true;
}

automotive_navigation_msgs__msg__RoadNetworkBoundaries *
automotive_navigation_msgs__msg__RoadNetworkBoundaries__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  automotive_navigation_msgs__msg__RoadNetworkBoundaries * msg = (automotive_navigation_msgs__msg__RoadNetworkBoundaries *)allocator.allocate(sizeof(automotive_navigation_msgs__msg__RoadNetworkBoundaries), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(automotive_navigation_msgs__msg__RoadNetworkBoundaries));
  bool success = automotive_navigation_msgs__msg__RoadNetworkBoundaries__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
automotive_navigation_msgs__msg__RoadNetworkBoundaries__destroy(automotive_navigation_msgs__msg__RoadNetworkBoundaries * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    automotive_navigation_msgs__msg__RoadNetworkBoundaries__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
automotive_navigation_msgs__msg__RoadNetworkBoundaries__Sequence__init(automotive_navigation_msgs__msg__RoadNetworkBoundaries__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  automotive_navigation_msgs__msg__RoadNetworkBoundaries * data = NULL;

  if (size) {
    data = (automotive_navigation_msgs__msg__RoadNetworkBoundaries *)allocator.zero_allocate(size, sizeof(automotive_navigation_msgs__msg__RoadNetworkBoundaries), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = automotive_navigation_msgs__msg__RoadNetworkBoundaries__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        automotive_navigation_msgs__msg__RoadNetworkBoundaries__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
automotive_navigation_msgs__msg__RoadNetworkBoundaries__Sequence__fini(automotive_navigation_msgs__msg__RoadNetworkBoundaries__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      automotive_navigation_msgs__msg__RoadNetworkBoundaries__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

automotive_navigation_msgs__msg__RoadNetworkBoundaries__Sequence *
automotive_navigation_msgs__msg__RoadNetworkBoundaries__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  automotive_navigation_msgs__msg__RoadNetworkBoundaries__Sequence * array = (automotive_navigation_msgs__msg__RoadNetworkBoundaries__Sequence *)allocator.allocate(sizeof(automotive_navigation_msgs__msg__RoadNetworkBoundaries__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = automotive_navigation_msgs__msg__RoadNetworkBoundaries__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
automotive_navigation_msgs__msg__RoadNetworkBoundaries__Sequence__destroy(automotive_navigation_msgs__msg__RoadNetworkBoundaries__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    automotive_navigation_msgs__msg__RoadNetworkBoundaries__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
automotive_navigation_msgs__msg__RoadNetworkBoundaries__Sequence__are_equal(const automotive_navigation_msgs__msg__RoadNetworkBoundaries__Sequence * lhs, const automotive_navigation_msgs__msg__RoadNetworkBoundaries__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!automotive_navigation_msgs__msg__RoadNetworkBoundaries__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
automotive_navigation_msgs__msg__RoadNetworkBoundaries__Sequence__copy(
  const automotive_navigation_msgs__msg__RoadNetworkBoundaries__Sequence * input,
  automotive_navigation_msgs__msg__RoadNetworkBoundaries__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(automotive_navigation_msgs__msg__RoadNetworkBoundaries);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    automotive_navigation_msgs__msg__RoadNetworkBoundaries * data =
      (automotive_navigation_msgs__msg__RoadNetworkBoundaries *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!automotive_navigation_msgs__msg__RoadNetworkBoundaries__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          automotive_navigation_msgs__msg__RoadNetworkBoundaries__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!automotive_navigation_msgs__msg__RoadNetworkBoundaries__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
